
package de.ivu.elect.presentation.kandidatur.action;

import javax.inject.Inject;

import de.ivu.elect.business.kandidatur.boundary.DirektkandidaturConversationSelect;
import de.ivu.elect.business.kandidatur.entity.Direktkandidatur;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.kandidatur.WaehlerBenannteDirektkandidaturEditView;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;

public class WaehlerBenannteDirektkandidaturEditAction extends AbstractDirektkandidaturAction {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient DirektkandidaturConversationSelect direktkandidaturConversationSelect;

  public WaehlerBenannteDirektkandidaturEditAction() {
    super();
  }

  @Override
  public UseCasePermission getRequiredPermission() {
    return UseCasePermission.WAEHLER_BENANNTE_KANDIDATUR_EDIT;
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return getKandidaturEditGebietSecurity();
  }

  @Override
  protected boolean isDisabledInternal(Direktkandidatur direktkandidatur) {
    return !isWaehlerBenannteDirektkandidatur(direktkandidatur);
  }

  @Override
  protected String doIt(Direktkandidatur entity) {
    direktkandidaturConversationSelect.setEntity(entity);

    return WaehlerBenannteDirektkandidaturEditView.VIEW_ID;
  }

  @Override
  public String getLabelKey() {
    return "entity.edit.action.edit";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconEdit();
  }
}
